/* PICKREAD.PRG - Array popup picklist reader
   for Clipper 5.01's Get/read system.

COMPILE FOR TESTING WITH:
   CLIPPER pickread /n /w /m /b /dTESTING
   RTLINK FILE pickread

COMPILE FOR LIBRARY WITH:
   CLIPPER pickread /n /w /m /b /dTESTING
   LIB tools -+pickread;

*/

#include "inkey.ch"
#include "getexit.ch"
#include "setcurs.ch"

#ifdef TESTING

MEMVAR GetList
PROCEDURE Test()
   LOCAL nTotal:=   Val( "  0.00" )
   LOCAL cChrgTyp:= Space( 4 )
   LOCAL aChrgTyp:= { "VISA","M/C ","AMEX" }
   LOCAL cExpDate:= Space( 4 )
   LOCAL bReader:= {|g| PickReader(g,aChrgTyp) }
   SET SCOREBOARD OFF
   CLEAR SCREEN
   SET COLOR TO gr+/br,n/w,,,gr+/b
   @ 04,11 CLEAR TO 10,40
   @ 04,11 TO 10,40 DOUBLE
   @ 06,16 SAY "Total Amount" GET nTotal;
           VALID nTotal > 0
   @ 07,16 SAY "Charge Type " GET cChrgTyp;
           SEND reader:= bReader
   @ 08,16 SAY "Exp. Date   " GET cExpDate;
           PICTURE "@R 99/99";
           VALID !Empty( cExpDate )
   READ
   RETURN

#endif

PROCEDURE PickReader( g,aChoices )
   LOCAL t,l,b,r,xScr,nWid:= 0
   LOCAL nSelect
   LOCAL xCurs:= SetCursor( SC_NONE )
   LOCAL xColor:= SetColor( "bg+/r,n/w" )
   LOCAL nBefore:= LastKey()

   // Make this get active
   g:setFocus()

   // Determine length of longest element
   AEval( aChoices,;
          {|e| nWid:= Max( Len(e),nWid ) } )

   // Get box coords, draw box centered
   t:= ( MaxRow()-Len( aChoices ) )/2 - 1
   l:= ( MaxCol()-nWid )/2 - 2
   b:= t + Len( aChoices ) + 1
   r:= l + nWid+3
   xScr:= SaveScreen( t,l,b,r )
   @ t,l CLEAR TO b,r
   @ t,l TO b,r

   WHILE .T.
      nSelect:= AChoice( t+1,l+2,b-1,r-2,;
                         aChoices )
      DO CASE
      CASE LastKey() == K_ESC
         g:exitState:= GE_ESCAPE
         EXIT
      CASE LastKey() == K_ENTER
         g:varPut( aChoices[ nSelect ] )
         IF nBefore == K_UP
            g:exitState:= GE_UP
         ELSE
            g:exitState:= GE_DOWN
         ENDIF
         EXIT
      ENDCASE
   END
   RestScreen( t,l,b,r,xScr )
   SetColor( xColor )
   SetCursor( xCurs )

   g:killFocus()
   RETURN

// EOF
